Hot News aus dem CAD.de-Newsletter:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  Rund um AutoCAD
  Schwerpunkte für viele Polygone setzen oder Koorindatenliste

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
Autor Thema:   Schwerpunkte für viele Polygone setzen oder Koorindatenliste (2656 mal gelesen)
loneship
Mitglied
Bauingenieur, Geschäftsführer

Sehen Sie sich das Profil von loneship an!   Senden Sie eine Private Message an loneship  Schreiben Sie einen Gästebucheintrag für loneship

Beiträge: 4
Registriert: 17.08.2011

AutoCAD 2010, AutoCAD Civil 3D 2010

erstellt am: 17. Aug. 2011 10:15    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo Forum,

ich habe folgende Aufgabenstellung, für die ich bisher leider noch keine geeignete Lösung gefunden habe:

Ich habe eine AutoCAD-Zeichnung, in welcher sich hunderte von digitalisierten Baumkronen befinden. Jede Baumkrone wurde jedoch als Polygon gezeichnet, leider nicht als Kreis. Nun möchte ich gerne in den Schwerpunkt jeder einzelnen Polygonfläche (Baumkrone) einen Block platzieren, quasi als "Baumsymbol".

Ich habe in div. Foren schon Lisp-Programme gefunden, die den Flächenschwerpunkt ermitteln und als Punkt in der Zeichnung darstellen, jedoch immer nur für eine einzelne Fläche. Bei diesen Routinen muss man immer mit der Maus in jede einzelne Fläche klicken.
Auch bei der AutoCAD-Funktion MASSEIG wird immer nur ein Polygon berücksichtigt (aus ACAD-Hilfe: "Bei der Auswahl mehrerer Regionen werden nur diejenigen berücksichtigt, die in einer Ebene mit der ersten markierten Region liegen.").

Da sich in meiner Zeichnung aber hunderte von Bäumen befinden, suche ich nach einer Lösung oder Lisp-Routine, welche für alle seleketierten Polygone einen Block in den Schwerpunkt setzt.
Alternativ würde es auch ausreichend sein, die Flächenschwerpunkte aller Polygone als Koordinatenliste ausgeben zu lassen.

Kann mir da jemand weiterhelfen?

Vielen Dank!
Jens


[Diese Nachricht wurde von loneship am 17. Aug. 2011 editiert.]

[Diese Nachricht wurde von loneship am 17. Aug. 2011 editiert.]

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

CADmium
Moderator
Maschinenbaukonstrukteur




Sehen Sie sich das Profil von CADmium an!   Senden Sie eine Private Message an CADmium  Schreiben Sie einen Gästebucheintrag für CADmium

Beiträge: 13413
Registriert: 30.11.2003

Hinweis: Meine Mitarbeit auf CAD.DE ist fakultativ, unentgeltlich und beruht nur auf einem ausgeprägtem Helfersyndrom.

erstellt am: 17. Aug. 2011 10:23    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für loneship 10 Unities + Antwort hilfreich

Linien- oder Flächenschwerpunkt ? Oder ist das egal ?

------------------
      - Thomas -          
"Bei 99% aller Probleme ist die umfassende Beschreibung des Problems bereits mehr als die Hälfte der Lösung desselben."

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

loneship
Mitglied
Bauingenieur, Geschäftsführer

Sehen Sie sich das Profil von loneship an!   Senden Sie eine Private Message an loneship  Schreiben Sie einen Gästebucheintrag für loneship

Beiträge: 4
Registriert: 17.08.2011

AutoCAD 2010, AutoCAD Civil 3D 2010

erstellt am: 17. Aug. 2011 10:28    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

 
Zitat:
Original erstellt von CADmium:
Linien- oder Flächenschwerpunkt ? Oder ist das egal ?


Ich benötige jeweils den Flächenschwerpunkt aller Polygone, da es sich um Baumkronen handelt.
Der Flächenschwerpunkt soll dann ungefähr die Position des Stammes markieren.

[Diese Nachricht wurde von loneship am 17. Aug. 2011 editiert.]

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

CADmium
Moderator
Maschinenbaukonstrukteur




Sehen Sie sich das Profil von CADmium an!   Senden Sie eine Private Message an CADmium  Schreiben Sie einen Gästebucheintrag für CADmium

Beiträge: 13413
Registriert: 30.11.2003

Hinweis: Meine Mitarbeit auf CAD.DE ist fakultativ, unentgeltlich und beruht nur auf einem ausgeprägtem Helfersyndrom.

erstellt am: 17. Aug. 2011 10:55    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für loneship 10 Unities + Antwort hilfreich

Na dann wäre der ansatz :
1. Auswahl aller auszuwertenden Polygone
2. Durchlauf durch den Auswahlsatz, dabei für jedes Objekt:
2a. kopieren .... und aus der Kopie ne Region erstellen
2b. aus der Region Flächenschwerpunkt  auslesen
2c. Blockreferenz an dieser Koordinate erzeugen ( evtl. Block, wenn noch nicht vorhanden als Dummyblock erzeugen
2d Region wieder löschen

....

------------------
  - Thomas -          
"Bei 99% aller Probleme ist die umfassende Beschreibung des Problems bereits mehr als die Hälfte der Lösung desselben."

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

wronzky
Ehrenmitglied V.I.P. h.c.
CAD-Dienstleistungen für Architekten



Sehen Sie sich das Profil von wronzky an!   Senden Sie eine Private Message an wronzky  Schreiben Sie einen Gästebucheintrag für wronzky

Beiträge: 2154
Registriert: 02.05.2005

CAD:
AutoCAD 2.6 bis 2014
ADT 2005 bis ACA 2013
Arcibem
System:
Windows
Internet-Startseite:
http://www.archi.de

erstellt am: 17. Aug. 2011 10:58    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für loneship 10 Unities + Antwort hilfreich

wenn's schon Regionen sind, dann z.B. so:
Code:
(defun c:vox-center-points ( / as ele z)
  (vl-load-com)
  (setq as (ssget '((0 . "REGION"))) z -1)
  (while (setq ele (ssname as (setq z (1+ z))))
    (command "_point" (vlax-safearray->list (vlax-variant-value (vla-get-centroid (vlax-ename->vla-object ele)))))
  )
)

Grüsse, Henning

------------------
Henning Jesse
VoxelManufaktur
Computer-Dienstleistungen für Architekten und Ingenieure

  http://www.voxelman.de

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Goofy007
Mitglied
Vermessungstechniker


Sehen Sie sich das Profil von Goofy007 an!   Senden Sie eine Private Message an Goofy007  Schreiben Sie einen Gästebucheintrag für Goofy007

Beiträge: 578
Registriert: 06.11.2004

erstellt am: 17. Aug. 2011 11:03    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für loneship 10 Unities + Antwort hilfreich

Hallo Jens,

du hast ein Civil3D da sollte auch die Funktionalität von Map3D drinnen sein. Wenn du aus den Polygonen Topologien erzeugst kannst du hinterher deren Centerpoints exportieren, oder sonst was damit machen.
Ich weiß bloß nicht auswendig, ob der Centerpoint genau der Flächenschwerpunkt ist.
Ich ich könnte mir vorstellen, dass es für "Stammfindung" genau genug ist. Und die GIS-Werkzeuge hätten halt den Vorteil, dass es egal ist wie viele Bäume du hast. GIS ist sowiso immer für Massenverarbeitung gedacht.

lg
Didi

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

loneship
Mitglied
Bauingenieur, Geschäftsführer

Sehen Sie sich das Profil von loneship an!   Senden Sie eine Private Message an loneship  Schreiben Sie einen Gästebucheintrag für loneship

Beiträge: 4
Registriert: 17.08.2011

AutoCAD 2010, AutoCAD Civil 3D 2010

erstellt am: 17. Aug. 2011 11:25    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Zitat:
Original erstellt von wronzky:
wenn's schon Regionen sind, dann z.B. so:
Code:

...
(command "_point" (vlax-safearray->list (vlax-variant-value (vla-get-centroid (vlax-ename->vla-object ele)))))
...



Deine LISP geht genau in die Richtung, was ich suche. Klasse!
Regionen kann ich ja einfach mit dem Befehl REGION erstellen. Das macht ACAD ja auch für alle selektierten Objekte.
Gut, wenn's automatisch wär, ist es natürlich besser, aber das ist eher nebensächlich.

Da ich leider nicht so bewandert in LISP bin:
Wie könnte man anstatt der Punkte nun Blöcke setzen (den einzufügenden Block kann ich ja zuvor in der Zeichnung erstellen)?

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

wronzky
Ehrenmitglied V.I.P. h.c.
CAD-Dienstleistungen für Architekten



Sehen Sie sich das Profil von wronzky an!   Senden Sie eine Private Message an wronzky  Schreiben Sie einen Gästebucheintrag für wronzky

Beiträge: 2154
Registriert: 02.05.2005

CAD:
AutoCAD 2.6 bis 2014
ADT 2005 bis ACA 2013
Arcibem
System:
Windows
Internet-Startseite:
http://www.archi.de

erstellt am: 17. Aug. 2011 12:01    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für loneship 10 Unities + Antwort hilfreich

dann statt
Code:
(Command "_point" (vlax-save.....))
Code:
(command "_.insert" "[HIER_BLOCKNAME]" (vlax-save.....) 1 1 0)
Grüsse, Henning

------------------
Henning Jesse
VoxelManufaktur
Computer-Dienstleistungen für Architekten und Ingenieure

  http://www.voxelman.de

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

loneship
Mitglied
Bauingenieur, Geschäftsführer

Sehen Sie sich das Profil von loneship an!   Senden Sie eine Private Message an loneship  Schreiben Sie einen Gästebucheintrag für loneship

Beiträge: 4
Registriert: 17.08.2011

AutoCAD 2010, AutoCAD Civil 3D 2010

erstellt am: 17. Aug. 2011 15:32    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo Henning,

vielen Dank für Deine Unterstützung. Das hat mit 2D-Polylinien auch funktioniert.

Jetzt habe ich aber festgestellt, dass alle Polygone (Baumkronen) als 3D-Polylinien gezeichnet sind und jeder der Stützpunkte eine andere Höhe hat (alle auf der unter dem jeweiligen Randpunkt der Baumkrone befindlichen Geländehöhe, die daher immer unterschiedlich ist).

Ich habe zunächst in MAP 2010 mit MAPCLEAN die 3D-Polylinien in normale Polylinien konvertiert. Dann konnte ich Regions daraus bilden. Wenn ich aber dann die Lisp-Routine ausführe, gibt ACAD die Meldung aus, dass sich die Region nicht auf BKS-Ebene befindet. Das kann ich auch nachvollziehen, da die Höhen der einzelnen Stützpunkte unterschiedlich sind.
Ich möchte aber die Z-Höhen nicht verlieren, d.h. die Geländehöhen für den Stamm. Daher wäre wahrscheinlich doch eine Lösung gut, bei welcher dann doch nicht der Flächenschwerpunkt, sondern der Volumenschwerpunkt mit einem Block gezeichnet wird. Das dürfte dann in etwa dem mittleren Höhenwert des Geländes entsprechen.
Ich möchte also immer einen Block auf Geländehöhe setzen lassen, wo sich der Stamm befindet.

Oder denke ich da falsch?

Vielen Dank und Gruß
Jens

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

cm-Zeichner
Mitglied
Vermessungstechniker


Sehen Sie sich das Profil von cm-Zeichner an!   Senden Sie eine Private Message an cm-Zeichner  Schreiben Sie einen Gästebucheintrag für cm-Zeichner

Beiträge: 149
Registriert: 23.07.2009

Win7Pro 64Bit, AutoCAD Map3D 2014 64Bit

erstellt am: 21. Sep. 2017 14:07    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für loneship 10 Unities + Antwort hilfreich

Wie kann ich den Schwerpunkt übergeben?

Im Bespiel unten ist ENAME das zugewiesene Element (-eine Region).

Code:

(command "_.REGION" ENAME "")
(command "_.MASSPROP" "_LAST" "" "_NO")

Damit bekomme ich jetzt die Eigenschaften der gewählten Region am Bildschirm angezeigt. Auch die Koordinaten des Schwerpunktes.

Diesen möchte ich nun an die Variable XY_TEXT übergeben, in etwa so:

(setq XY_TEXT Schwerpunkt-Region)

Wie geht das?

Gehört zwar glaub ich ins LISP-Forum, da aber schon hier begonnen wurde mach ich auch hier weiter.

Herzlichen Dank

------------------
Grüße Bernd

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

CADwiesel
Moderator
CAD4FM UG




Sehen Sie sich das Profil von CADwiesel an!   Senden Sie eine Private Message an CADwiesel  Schreiben Sie einen Gästebucheintrag für CADwiesel

Beiträge: 1896
Registriert: 05.09.2000

AutoCAD, Bricscad
Wir machen das Mögliche unmöglich

erstellt am: 22. Sep. 2017 09:34    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für loneship 10 Unities + Antwort hilfreich

hatten wir erst Letztens
http://ww3.cad.de/foren/ubb/Forum54/HTML/033634.shtml#000006
sieh dir das Tool an da siehst du wie ein Weg sein könnte


------------------
Gruß
CADwiesel
Besucht uns im CHAT

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

cm-Zeichner
Mitglied
Vermessungstechniker


Sehen Sie sich das Profil von cm-Zeichner an!   Senden Sie eine Private Message an cm-Zeichner  Schreiben Sie einen Gästebucheintrag für cm-Zeichner

Beiträge: 149
Registriert: 23.07.2009

Win7Pro 64Bit, AutoCAD Map3D 2014 64Bit

erstellt am: 22. Sep. 2017 11:25    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für loneship 10 Unities + Antwort hilfreich

Danke - das war´s.
Schönes Wochenende

------------------
Grüße Bernd

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2019 CAD.de | Impressum | Datenschutz